var maxResCount = 6; //will res twice and stop

var MIN_BAG_SPACE = 2; //will go to sale if only 2 spaces available in bag.
//function called after each fishing
var lastCastTime = 0;

var authSockets = {};

var resCount = 0; //res count;

var curChannelCallback = null;  //2008-11-22 added for callbacks during channeling.



function processWowMessages() {
  if (wowjs.curState == "selectmob") {
    var tryTarget = wowjs.botSelectedTarget;
    if (tryTarget != null) {
      var dist = fDist3D(tryTarget.x, tryTarget.y, tryTarget.z);
      //wowjs.wowLog("try to select mob "+ tryTarget.wowId+" dist " + dist);
      //stop run if distance too close.
      if (dist < 6) {
        wowjs.wowStopRun();
      }
    }
    //var target = me.target;
    //if (target == null) wowjs.wowLog("SELMOB no target");
    //else {
    //  wowjs.wowLog("SELMOB target "+ target.name+" dist " + fDist3D(target.x, target.y, target.z));
    //}
    return;
  }
  if (wowjs.curState == "premob") {
    wowjs.wowLog("state premob");
    var tryTarget = wowjs.botSelectedTarget;
    if (tryTarget != null) {
      var dist = fDist3D(tryTarget.x, tryTarget.y, tryTarget.z);
      wowjs.wowLog("pre-sel dist to mob " + dist);
  
      wowjs.wowLog("Pre Selecting mob, dismount");
      me.wowDoFightAction("quickdismount");
    }
    return;
  }
  if (me.curState == "onroad") {  //running
    return; 
  }
  if (me.curState == "approach") {
    return;
  }
  if (me.curState == "mobtoofar") {
    var target = me.target;
    if (target != null) {
      var dist = fDist3D(target.x, target.y, target.z);
      wowjs.wowLog("mob too far dist="+dist+", try to run to "+target.name);
      if (dist < 45) {
         var myreach = me.myCombatReach;
         wowjs.wowLog("my reach is " + myreach);
         myreach = myreach - 5;
         if (myreach < 0) myreach = 5;
         wowjs.wowRunTo(target.x, target.y, 6, myreach);
      }
    }
    return;
  }

  //first time we are on.
  if (me.curState == "onstart") {
    wowjs.wowLog("onstart");
    wowjs.wowCheckAndRest();  //check if we need rest.
        wowjs.wowLog("end onstart");
    return;
  }

  //me.wowLog(me.curState);
  //////
  //  NOTE: the states above processFishing() must return immediately or there could be recurisive problems.
  //
  if (me.curState == "waypointTimeout")
  {
    me.wowLog("waypointTimeout");
    if (battleGroupExitCheck != null) {
      battleGroupExitCheck();
    }
    //zstorm's unstuck script.
    checkStuck();
    return; //must return to avoid recurisive loop
  }
  
  if (me.curState == "inCooldown") {
    return; //don't do much in cooldown, it breaks looting.
  }
  if (me.curState == "inChannel") {
    if (curChannelCallback != null) curChannelCallback();
    if (wowjs.fighterBGMode == 'BG')  return true;
    var mytarget = me.target;
    //me.wowLog("inchannel my target " + mytarget);
    if (mytarget != null) {
      //me.wowLog("inchannel checking my target " + mytarget.name);
      var target = mytarget.target;    
      //me.wowLog("inchannel checking my target's target is " + target);
      if (target != null) {
         //me.wowLog("checking my target is targeting " + target.name);
         var targetme = target.wowIsSameObj(me);
         var targetpet = target.wowIsSameObj(me.wowGetSummon());
         var targetself = target.wowIsSameObj(target);
         //me.wowLog("checking mob tag me " + targetme+ " mob target pet " + targetpet+ " self " + targetself);
         if (targetme || targetpet || targetself) {
           //if target me or pet, it is ok
           //me.wowLog("he is attacking me");
           return true;
         } else {
           //me.wowLog("he is attacking OTHERS1 " + target.name+", aborting");
           //abort fight
           me.wowAbortCurFight = true;
           me.wowSleep(100);
           me.wowLog("sending space");
           fPressKeyStd(wowjs.wowKeySpace);
           me.wowLog("done space");
           me.wowLog("he is attacking OTHERS2 " + target.name+", aborting");
           return false;
         }
      }
    }
    return true;
  }

  if (me.curState == "rest") {
    //in rest mode, only check messages, don't try to loot
    doRemoteControl();
    checkMessages();
    resetStuck();
    return;
  }  

  if (me.curState == "dead") {
    me.wowLog("state dead");
    resetStuck();  
    return;
  }
 
  if (me.curState == "graveyard")
  {
    me.wowLog('in graveyard ');
    me.wowSleep(4000);
    resetStuck();
    if (wowjs.fighterBGMode == 'BG') {
       //if battle ground mode, just wait for 30s for the spirit healer.
       me.wowLog("in bg mode, dead " + me.health);
       for (var bgWait = 0; bgWait < 30; bgWait++) {
         me.wowSleep(1500);  //wait 1.5second for each check
         if (me.health > 1) {
           break;
         }
       }
    }
  }

  

  //pre resurection
  if (me.curState == "preres") {
    me.wowLog("pre rez, count " + resCount + " of " + maxResCount);
    resCount = resCount + 1;
    if (resCount >= maxResCount) {
      wowjs.wowLog("res limit reached");
      me.wowBotStop();
    }
    wowjs.wowClearGlobalActs();
    //findBestResSpot();
    resetStuck();
    return;
  }

  if (me.curState == "resed") {
    wowjs.wowCheckAndRest();
resetStuck();
  }

  if (me.curState == "postLoot") {
    adjustWaypoint();
    //do some post loot check, for example, if target is still lootable, try to loot again
    me.wowLog("post loot " + me.inZoloLoot);
    if (me.inZoloLoot == true) return; //prevent recurisive loot.
    var lastTarget = me.lastFightTarget;
    if (lastTarget != null) {
      if (lastTarget.lootable) {
        var x = (me.x - lastTarget.x);
        var y = (me.y - lastTarget.y);
        var dist = Math.sqrt(  x*x + y*y );
        if (dist < 6) {
          wowjs.wowLog("found lootable, looting");
        me.inZoloLoot = true;
        me.wowDoLoot(lastTarget, 0, 100); //loot 100 pixel below standard loot position
        me.inZoloLoot = false;
        } else {
              me.wowLog("post loot: target too far " + dist);
        }
      }
    } 
    if (me.inCombat == false)me.wowSleep(500);  //added a 1 second sleep
    processLootCorpse();
    resetStuck();
    return;
  }
  if (me.curState == "afterRest") {
    processLootCorpse();
    me.wowDoFightAction("mount");
    resetStuck();
    return;
    //me.curState == "inCooldown"
  } else if (me.curState == "preLoot") {
    resetStuck();
    me.wowLog("in state preLoot");
    var lastTarget = me.lastFightTarget;
    me.wowLog("last target " + lastTarget);
    if (lastTarget != null) {
      me.wowLog("last mob fought " + lastTarget.name);
      me.wowSleep(500);
      if (lastTarget.lootable == false) {
        me.wowLog("target not lootable");
        me.wowAbortCurFight = true;
        return;
      }
      else {
        me.wowLog("target lootable");
        return;
      }
    }
  } else
  if (me.curState == "afterFight" || me.curState == "resed") {
    if (wowjs.jsplevelChecker != null) {
      wowjs.wowLog("checking level");
      wowjs.jsplevelChecker();
    }

    processSummon(); //try to summon pet after fight or after res
    resetStuck();
    return;
  }

  if (wowjs.jsplevelChecker != null) {
    wowjs.wowLog("checking level");
    wowjs.jsplevelChecker();
  }

  if (me.curState != "onsale") {
    processTryGoToVendorSale();
  }

  processFishing();
  if (wowjs.lootLevel == 0) {
    processLootCorpse();
  }
  if (me.followZ != 0)
    followWaypointZ();

  checkTimeOut();
  doRandJump();
  //zstorm's unstuck script.
  checkStuck();

  //try to invoke pick pocket
  if (wowjs.pocketPickFunc != null) wowjs.pocketPickFunc();
  
  //if (me.curState != "msg")
  //  me.wowLog(me.wowClassName+": cur state " + me.curState); //dead, resed, timeout, afterFight, preres
  // ///// preres means pre - resurect.  You can call me.wowBotStop(); to stop before resurect.

  checkFollow();

  checkMine();

  //remote control/monitor calls
  doRemoteControl();

  checkMessages();
  herbMineCheck();
}

var lootedObjs = {};
var onWayCollectItems = false;
function herbMineCheck() {
  if (onWayCollectItems)return;
  var goodItemsAry = [];
  var pos = 0;
  //wowjs.wowLog("herb mine check");  
  for (var i = 0; i < wowjs.itemCount; i++) {
    var itm = wowjs.wowGetItem(i);	
    if (wowjs.wowIsCollectableItem(itm.name) && lootedObjs[itm.wowId]!= true) {
       //wowjs.wowLog("found herb " + itm.name+" valid="+itm.valid+" id="+itm.wowId+" x="+itm.x+" y="+itm.y);
       if (itm.valid == false) continue;
       var pathes = wowjs.wowOrbiterGetPath(me.x,me.y,me.z, itm.x, itm.y, itm.z);
       if (pathes == null || pathes.length == 0) {
         wowjs.wowLog("check herb path error");
         continue;
       }
       //wowjs.wowLog("path " + pathes+" ntotalDist = " +pathes.totalDist+" len="+pathes.length + " last dist="+pathes[pathes.length-1].dist);
       if (pathes[pathes.length-1].dist <= wowjs.itemLootDist) {
         wowjs.wowLog("good item " + itm.name+" dist " + pathes.totalDist);
         goodItemsAry[pos] = pathes;
         pathes.origItm = itm;
         pos++;
       }
    }
  }

  if(goodItemsAry.length > 0) {
    goodItemsAry.sort(sortHerbFunc);
    onWayCollectItems = true;
    var pathes = goodItemsAry[0];
    var itm = pathes.origItm;
         wowjs.wowLog("herb/mine: going to good item " + itm.name+ " dist " + pathes.totalDist);
         wowjs.wowOrbitRunTo(itm.x, itm.y, itm.z,"herb");
         wowjs.wowLog("reached good item " + itm.name);
         onWayCollectItems = false;
         var itmDist = checkDistToMe(itm);
         if (itmDist <= wowjs.itemLootDist+2) {
           wowjs.wowTurnTo(itm.x, itm.y);
           wowjs.wowRunTo(itm.x, itm.y, 6, 4);
           for (var jj = 0; jj < 5; jj++) {
             wowjs.wowLog("herb/mine looting " + jj+ " " + itm.name);
             if (wowjs.wowDoLoot(itm) != true) {
               wowjs.wowLog("debug remove loot failed"); break;
             }
             if (!itm.valid) { wowjs.wowLog("debug remove invalid obj"); break;}
           }
           lootedObjs[itm.wowId] = true;
           me.wowDoFightAction("mount");
         } else {
           wowjs.wowLog("item dist too far " + itmDist);
         }
         wowjs.wayPointPos = -1;
         //break;
    
  }
  resetStuck();
}

function sortHerbFunc(a,b)
{
  return a.totalDist - b.totalDist;
}

function doStone(){
  me.wowStopRun();
  me.wowBotStop();
  me.wowDoFightAction("stone");
}

var userReplyCount = {};  //records username => how many times we have replied to them.
function checkMessages(){
  //DTK's script to check player speaking or whisper near me
  var mesgs = me.wowGetMessages();
  for (var i =0; i < mesgs.length; i++) {
    var wmsg = mesgs[i]; //me.wowGetMsg(i);
    me.wowLog("msg= " + i + " " + wmsg); 
    wowjs.wowFileLog("loggedmessages.txt",wowjs.curtimeStr+":"+wmsg+"\n");

    //send messages to remote connected sessions if any
    for (var skt in authSockets) {
      if (authSockets[skt] == "RMTCTL") {
        wowjs.wowSendRemoteMsg(skt, "MSG:"+wmsg+"\n");
      }
    }
    
    
    var match =  /Type: \[([0-9]+)\], Channel: \[(.*)\], Player Name: \[(.*)\], Text: \[(.*)\]/g;
    var res= match.exec(wmsg);
    match.exec();
    if (res != null) {
      var msgtype = res[1];
      var msgchan = res[2];
      var msgplyr = res[3];
      var msgtext = res[4];
      me.wowLog("type= " + msgtype+" chn = " + msgchan+" p=" +  msgplyr+" txt:" + msgtext);      
      if (msgtype == 7) {
         if (whisperReplies != null && whisperReplies.length != 0) {
            //the chance of replying a user gets smaller and smaller
            var cnt = userReplyCount[msgplyr];
            if (cnt == null) cnt = 0;
            var rnd = Math.floor(Math.random()*10);
            wowjs.wowLog("reply random is " + rnd+ " and reply threadshold is " + (cnt*2));
            if (rnd > (cnt*2)) {
              var which = Math.floor(Math.random()*(whisperReplies.length-1));
              me.wowTalkViaClipboard("/r "+whisperReplies[which]);
              cnt++;
              userReplyCount[msgplyr] = cnt;
            }
         }
         //instead of stop bot and stone, just make a beep or your wave file here.
         //doStone();
         me.wowPlaySound("whisper.wav");
      }
      else
      {
         //6 is whisper, 0 is public
         var playersNearMe = me.wowGetPlayers();
         for (var j in playersNearMe) {
           var player = playersNearMe[j];
           if (player != null) {
             if (player.name == msgplyr) {               
               {
                 //if speaking, check distance, if longer than 20 yard, most likely not to me
                 var xdif = me.x - player.x;
                 var ydif = me.y - player.y;
                 var dist = Math.sqrt( (xdif*xdif) + (ydif*ydif) );
                 me.wowLog("=======> player " + player.name + " pos " + player.x+" "+player.y + " distance to player " + dist);
                 if (dist < 25) {
                   me.wowPlaySound("whisper.wav");
                   //doStone();
                 }
               }
             }
           }
         }
      }
    }
  }
  me.wowClearMsgs();  //clear out messages
}


//adjust next waypoint to the one closest to me
//usefull after loot.
function adjustWaypoint() {
    wowjs.wowLog("Adjust waypoint");
    wowjs.curRunPointBreak = "true";
}

function getDistToNearstMob(x,y) {
  for (var i = 0 ;i < me.toonCount; i++) {
    var toon = me.wowGetToon(i);
    if (!toon.isPlayer) {          
      if (toon.isAttackAbleFaction) {
        var xx = x - toon.x;
        var yy = y - toon.y;
        xx = xx * xx;
        yy = yy * yy;
        var dist = Math.sqrt(xx+yy);
        return dist;
      }
    }
  }
  return 0;
}

//find best spot to res
function findBestResSpot(){
  var curPos = wowjs.wayPointPos;
  var start = curPos - 25;
  var end = curPos + 25;
  if (start < 0) start = 0;
  if (end > wowjs.wayPointCount) end = wowjs.wayPointCount;
  var minDist = 9999999;
  var minPos = curPos;
  for (var i = start; i < end; i++) {
    //wowjs.wowLog("at " + i +"/"+ end+" "+ wowjs.wayPointCount);
    var wp = wowjs.wowGetWaypointAt(i);
    var x = wp[0] - wowjs.corpseX;
    var y = wp[1] - wowjs.corpseY;
    var distToCorpse = Math.sqrt((x*x) + (y*y));
    //wowjs.wowLog("dist to corpse " + distToCorpse+" "+x+","+y+"  " + wp[0]+","+wp[1]);
    if (distToCorpse > 10) continue;
    var dist = getDistToNearstMob(wp[0], wp[1]);
    //wowjs.wowLog("dist to nearst mob is " + dist + " at " + i);
    if (dist < minDist) {
       minDist = dist;
       minPos = i;
    }
  }
  if (curPos != minPos) {
    wowjs.wowLog("need to res from " + curPos +" to " + minPos);
    wowjs.wayPointPos = minPos;
    wowjs.curRunPointBreak = "true";
    var inc = 1;
    if (minPos < curPos)inc=-1;
    for (var thePos = curPos; thePos != minPos; thePos += inc) {
       if (wowjs.wowBotRun == false) break;
       var wp = wowjs.wowGetWaypointAt(thePos);
       if (wp == null) {
         wowjs.wowLog("Bad curPos in res, break");
         break;
       }
       //x,y, timeoutInSeconds
       wowjs.wowLog("going to " + wp[0]+","+wp[1]);
       wowjs.wowRunToNC(wp[0], wp[1], 10);
    } 
  }  
}

//stores player
var playerFollowTimeCheck = {};
function checkFollow() {
  var playersNearMe = me.wowGetPlayers();
  var hasNames = {};
  for (var j in playersNearMe) {
    var player = playersNearMe[j];
    if (player != null) {
      hasNames[player.name] = 1;
               //if speaking, check distance, if longer than 20 yard, most likely not to me
               var xdif = me.x - player.x;
               var ydif = me.y - player.y;
               var dist = Math.sqrt( (xdif*xdif) + (ydif*ydif) );
               if (dist < 50) {
                 if (playerFollowTimeCheck[player.name] == null) {                   
                   me.wowLog("found player " + player.name + " pos " + player.x+" "+player.y + " distance to player " + dist+" " + j + " " + player);
                 }
                 playerFollowTimeCheck[player.name] = wowjs.curTime;
               }else{
                 playerFollowTimeCheck[player.name] = null;
               }                      
    }
  }

  //remove away players  
  for (var i in playerFollowTimeCheck) {
    if (hasNames[i] == null) playerFollowTimeCheck[i] = null;
  }

  for (var i in playerFollowTimeCheck)
  {
    var followTime = playerFollowTimeCheck[i];
    if (followTime != null) {
      if (wowjs.curTime - followTime > 60*5) {
         wowjs.wowLog("player " + i+" followed too long");
         me.wowPlaySound("followstop.wav");
         doStone();
      }
    }
  }
  
}


//doRandJump has 10% chance to jump.
//thanks Pillow Pants for the math code.
function doRandJump() {
  var jmpPct = wowjs.wowGetBotSetting("JUMP");
  if (jmpPct == "" || jmpPct == "0") return;
  var randNum = Math.floor(Math.random()*10);
  //number 1 means 10% chance to jump, because randNum is between 0 and 9
  if (randNum < parseInt(jmpPct)) {
    //send a space to jump
    fPressKeyStd(wowjs.wowKeySpace);
  }
} 

function checkDistToMe(obj){
  var dx = me.x - obj.x;
  var dy = me.y - obj.y;
  dx = dx*dx;
  dy = dy*dy;
  return Math.sqrt(dx+dy);
}

function processFishing() {
  //only do it if mode is fishing.
  if (wowjs.fighterMode != 'fishing') return;
  
  if (me.waypointNoteComment != "") {
    me.wowStopRun();
    var lureName = "Bright Baubles";//"Aquadynamic Fish Attractor";
    var waitTime = 330;
    if (me.curTime - lastCastTime > waitTime) {
      lastCastTime = me.curTime;

      //Note: if you have defined a Macro, you can also put the macro on your action bar and
      // just send a key to active the macro.  To make it easy (so you don't need a macro),
      // I just let it type out the entire thing.
      me.wowLog("!!!!!!!!!!!!!!! applying "+me.lureName);
      me.wowSendString("/use " + lureName + "\n");
      me.wowSendString("/use 16\n");

      me.wowWait(10000); //wait channel for 10000ms, or 10s. It will done after lure applied.
      me.wowLog("done wait");
    }

    me.wowLog("!!!!! state " +me.heading+ " " + me.waypointNoteHeading+" comment " + me.waypointNoteComment); 
    me.wowStopRun();
    me.wowTurnToRad(me.waypointNoteHeading);
    
    for (var fcnt = 0; fcnt < 10; fcnt++){
      me.wowTurnToRad(me.waypointNoteHeading);
      me.wowLog("  fishing at " + fcnt);
      if (me.wowBotRun == false) break;
      var res = me.wowDoFishing();
      if (res) me.wowLog("Caught Fish");

      for(var i = 0; i < me.itemCount; i++) {
        var itm = me.wowGetItem(i);
        if (itm.name == "Highland Mixed School") {
          if (checkDistToMe(itm) < 20) {
            //if found highland mixed school 20 yards within me, reset count so we stay here.
            me.wowLog("item " + itm.name+" " + itm.x+ " " + itm.y);
            fcnt = 0;
          }
        }
      }

      if (me.inCombat) {
        me.wowLog("incombat");
        //some mob hitting me.
        me.wowOneFight();
      }
    }
    me.wowLog("  going to next spot");
  }
}


/////////////// example of how to get inventories in each bag.
//  call this function anywhere to show inventory.
function showInventory(){
  for (var i = 1; i<= 5; i++) {
    var container = me.wowGetContainer(i);
    if (container == null) continue;
    me.wowLog("Container " +container.name+ " size " + container.containerSize);
    for (var j = 0; j < container.containerSize; j++) {
      var itm = me.wowGetContainerItem(i,j);
      if (itm != null)
      me.wowLog(j+"	item " + itm.name+" stack " + itm.itemStackCount + " dur " +itm.itemDurability+ " " + itm.itemMaxDurability);
    }
  }
}


function canLoot() {
  return getInventoryFreeSpace() > MIN_BAG_SPACE;
}

function getInventoryFreeSpace(){
  var total = 0;
  var used = 0;
  for (var i = 1; i<= 5; i++) {
    var container = me.wowGetContainer(i);    
    if (container == null) continue;
    total = total + container.containerSize;     //total is all container size added together
    for (var j = 0; j < container.containerSize; j++) {
      var itm = me.wowGetContainerItem(i,j);     
      if (itm != null) used++;   //foreach non-empty spot, used count up.
    }
  }
  var free = total - used;
  //me.wowLog("bag space " + free+" total " + total+" used " +used);
  return free;
}


//if durability < 20%, return true to repair.
function checkNeedRepair() {
  //me.itemCount is total number of items
  var itemNumbers = [0,2,4,5,6,7,8,14,15];
  var allItems = me.wowGetMyItems();
  var needRepair = false;
  var count = 0;
  for (var i in itemNumbers) {
    var item = allItems[itemNumbers[i]];
    if (item != null) {
      if (item.itemMaxDurability != 0) {
        var pct = item.itemDurability/item.itemMaxDurability;
        if (pct < 0.2) {
          needRepair = true;
          wowjs.wowLog(" item " + item.name+" "+item.itemDurability+"/"+item.itemMaxDurability+" need repair " + pct);
        }
      }
      //else
      //wowjs.wowLog("item "+itemNumbers[i]+" " + item.name+" max dur=0 dur="+item.itemDurability);
      count++;
    }
  }
  if (count == 0) {
     wowjs.wowLog("repair Warning: no items found");
     return false;
  }
  return needRepair;
}

function processTryGoToVendorSale(){
  if (me.health <= 1) return; //don't do it if we are dead.
  var invgood = getInventoryFreeSpace() > MIN_BAG_SPACE;
  var durgood = !checkNeedRepair();
  
  if (invgood && durgood) return;
  
  var salesNpcs = wowjs.saleRepairNpcs;
  var hasSales = (salesNpcs != null) && (salesNpcs.length > 0);

  var hasRepairNpc = false;
  if (!durgood) {
    //need to find repair npcs
    for (var i = 0; i < salesNpcs.length; i++) {
      var npc = salesNpcs[i];
      if (npc.type == "repair") {
        hasRepairNpc = true;
      }
    }
    if (!hasRepairNpc) hasSales = false;
  }

  if (!hasSales) {
     if (wowjs.wowGetBotSetting("STOPWHENBAGFULL") == "Y") {
         wowjs.wowLog("stop because bag full or need repair " + invgood+","+durgood);
         //when run out of space and no sales waypoint, stop bot.
         wowjs.wowDoFightAction("mount");
         wowjs.wowSendString("                     ");
         wowjs.wowBotStop();
     }
     wowjs.wowLog("no sales/repair");
     return;
  }

  if (wowjs.zoloOnVendor == "true") return; //this must be in to prevent total recurisive death.
  //only try to sale if we have npc to sale to

  //find nearst sales guy.
  var nearstNpc = null;
  var shortestDist = -1;
  for (var i = 0; i < salesNpcs.length; i++) {
    var npc = salesNpcs[i];
    if (!durgood) if (npc.type != "repair") continue;
    var pathes = wowjs.wowOrbiterGetPath(me.x, me.y, me.z, npc.x, npc.y, npc.z);
    if (pathes.length > 0) {
     if (shortestDist < 0) {
       shortestDist = pathes.totalDist;
       nearstNpc = npc;
     } else if (shortestDist > pathes.totalDist){
       shortestDist = pathes.totalDist;
       nearstNpc = npc;
     }
    }
  }

  if (nearstNpc == null) {
    wowjs.wowLog("Can't reach sales npc, abort");
    return;
  }

  wowjs.wowStopRun();  //stop and mount
  wowjs.wowDoFightAction("mount");
  wowjs.zoloOnVendor = "true";
wowjs.wowPassiveFight = 1;
  while (wowjs.wowBotRun) {
    var res = wowjs.wowOrbitRunTo(nearstNpc.x, nearstNpc.y, nearstNpc.z, "onsale");
    if (res != null && res != "") {
       wowjs.wowLog("error go to sales/repair npc " + res);
       wowjs.wowBotStop();
       return;
    }
    var distToVendor = fDist3D(nearstNpc.x, nearstNpc.y, nearstNpc.z);
    wowjs.wowLog("distance to vendor " + distToVendor);
    if (distToVendor < 15){
      break;
    }
  }
  wowjs.wowRunToNC(nearstNpc.x, nearstNpc.y, 10, 5); // run to npc, timeout in 10 seconds, must to 5m of him
wowjs.wowPassiveFight = 0;
  endSaleLand();
wowjs.wowLog("end of sale, on vendor is " + wowjs.zoloOnVendor);
  processFindVendorToSale();   
  wowjs.zoloOnVendor = "false";
  wowjs.curRunPointBreak = "true";  //break the current and let Orbiter make a new one.
  wowjs.wayPointPos = -1;
}

function processFindVendorToSale(){
  if (wowjs.zoloOnVendor == "true") {
    var needRepair = checkNeedRepair();
    me.wowLog("dbgrmm processing onVendor, toon cnt " + me.toonCount);
    for (var i = 0 ;i < me.toonCount; i++) {
      if (!wowjs.wowBotRun)break;
      var toon = me.wowGetToon(i);
      if (toon.isPlayer == false) {
         //found npc
         //me.wowLog("toon " + toon.name+ " sale? " +toon.isSaleRepairNpc);
         if (toon.isSaleRepairNpc == "sales" || toon.isSaleRepairNpc == "repair") {
            if (needRepair) if (toon.isSaleRepairNpc != "repair") continue;
            var dist = getDistToMe(toon);
            //wowjs.wowLog("dist to sale/repair is " + dist);
            if (dist < 10) {
              wowjs.wowStopRun();
              me.wowTurnTo(toon.x, toon.y);               
              while ( (getDistToMe(toon) > 5) && wowjs.wowBotRun) {
                me.wowLog("closing on saler " + toon.name+ " dist " + getDistToMe(toon));
                me.wowSendKey(wowjs.wowKeyUp, 1);  //press and release the forward arrow key
                me.wowSleep(200);
                me.wowSendKey(wowjs.wowKeyUp, 0);
                me.wowSleep(200);
                me.wowTurnTo(toon.x, toon.y); 
	      }
              me.wowLog("found saler " + toon.name+ " dist " + dist);
              me.wowTurnTo(toon.x, toon.y); 
              me.wowDoLoot(toon);  //this will try to right click the toon 
              for (var trycnt = 0; trycnt < 3; trycnt++) {
                if (!wowjs.wowBotRun)break;
                me.wowSleep(1000);
                me.wowDoFightAction("saleToNpc");
                me.wowSleep(1000);
                me.wowLog("free space is now " + getInventoryFreeSpace());
                if (MIN_BAG_SPACE < getInventoryFreeSpace()) break;
              }
              for (var trycnt = 0; trycnt < 3; trycnt++) {
                if (!wowjs.wowBotRun)break;
                me.wowSleep(1000);
                me.wowDoFightAction("saleToNpc");
                me.wowSleep(1000);                
                needRepair = checkNeedRepair();
                me.wowLog("needRepair is now " + needRepair);
                if (!needRepair) break;
              }
              if (MIN_BAG_SPACE >= getInventoryFreeSpace()) {
                me.wowLog("failed to sale, stop");
                wowjs.wowBotStop();
              }
              if (needRepair) {
                me.wowLog("failed to repair, stop");
                wowjs.wowBotStop();
              }
              break;
            }            
         }
      }
    }
  }
}


var lootCounts = {};
var lastLootTime = {};
var herbCorpMobs = {'Withered Giant':1,
                    'Withered Bog Lord':1,
                    'Infested Protectors':1};
var mineCorpMobs = {};
function processLootCorpse() {
  //don't go loot if out of space.
  if (!canLoot()) {
     return;
  }
  //if in combat and some mob is attacking me, don't loot
  //this is because sometimes the combat flag didn't rest and will cause us to miss loot
  if (me.inCombat && wowjs.wowGetAttackingMob() != null) return;
  wowDoUnsafeRefresh();
  var allcorps = me.wowGetLootables();
  var looted = false;
  for (var i in allcorps) {
    var corp = allcorps[i];  
    //me.wowLog("corpse " + corp.name+ " lootable " + corp.lootable+" skinable " + corp.skinable);
    var bcanLoot = corp.lootable;
    if (me.doSkin) {
      //remove herb/mine corpses as skins.
      if (corp.skinable) {
          if ( (herbCorpMobs[corp.name] == null) 
            && (mineCorpMobs[corp.name] == null) 
          )
          bcanLoot = true;
      }
    }

wowjs.wowLog("herbCorpse is " + wowjs.herbCorpse+" herbmobname"+ corp.name+" val="+herbCorpMobs[corp.name]);
    if (wowjs.herbCorpse) {
      bcanLoot = bcanLoot || (herbCorpMobs[corp.name] == 1);
    }
    if (wowjs.mineCorpse) {
      bcanLoot = bcanLoot || (mineCorpMobs[corp.name] == 1);
    }

    var lootCount = lootCounts[corp.wowId];
    if (lootCount != null) {
      if (lootCount > 2) {
        var lapsedTime = wowjs.curTime - lastLootTime[corp.wowId];
        if (lapsedTime < (60*5)) {
          bcanLoot = false;
        }
      }
    }
    if (bcanLoot ) {      
      var x = (me.x - corp.x);
      var y = (me.y - corp.y);
      var dist = Math.sqrt(  x*x + y*y );
      if (lootCounts[corp.wowId] == null) lootCounts[corp.wowId] = 0;
      //me.wowLog("corpse " + corp.name+ " dist " + parseInt(dist) + " lootdist  " + me.itemLootDist+" cnt " + lootCounts[corp.wowId]);
      if (dist < me.itemLootDist ) {
        me.wowRunTo(corp.x, corp.y, 6, 5);
        me.wowLog("jslooting corpse");
        me.wowDoLoot(corp);
        me.wowLog("done looting corpse");
        me.wowSleep(1000);
        lootCounts[corp.wowId]++;
        lastLootTime[corp.wowId] = wowjs.curTime;
        looted = true;
      }
    }
  }
  resetStuck();
  if (looted) {
    adjustWaypoint();
  }
}

function processSummon() {
  if (wowjs.wowGetAttackingMob() != null) return;
  //if (me.curState == "afterFight")    
    //wowClassName is the <name> part of bindings_<name>.cfg, forexample, bindings_afwarlock.cfg, wowClassName is afworlock.
    if (me.wowClassName.indexOf("warlock") >= 0) {
      var pet = me.wowGetSummon();
      for (var i = 0; i < 6; i++) {
        pet = me.wowGetSummon();
        me.wowSleep(600);
        if (pet == null) {
          me.wowDoFightAction("summon");
        } else break;
      }
      var soulshardcnt = me.wowGetAllContainerItemCount("Soul Shard");
      me.wowLog("Sould shard count " + soulshardcnt);
      var manaPrecent = me.mana/me.maxmana;
      me.wowLog("mana precent=" + manaPrecent);
      while (manaPrecent < 0.8 ) {
        if (!wowjs.wowBotRun) break;
        pet = me.wowGetSummon();
        if (pet == null)break;
        me.wowLog("pet mana " + pet.mana+" me.level " + me.level);
        if (me.level > 40 && pet.mana > 400) {
          me.wowLog("Invoke action darkpact");
          me.wowDoFightAction("darkpact");
        } else break;
        manaPrecent = me.mana/me.maxmana;
        me.wowLog("pet mana pct " +manaPrecent);
        break;
      }

      if (pet != null) {
         if ( (pet.health/pet.maxhealth) < 0.5) {
            var oldcurChannelCallback = curChannelCallback;
            curChannelCallback = checkHealPet;
            me.wowDoFightAction("healpet");
            curChannelCallback = oldcurChannelCallback;
         }
      }
      
    }
}

function checkHealPet() {
  var pet = me.wowGetSummon();
  if (pet == null) return;
  wowjs.wowLog("checking healpet " + pet.health +"/"+ pet.maxhealth);
  if (pet.health == pet.maxhealth) {
    //stop heal pet.
    fPressKeyStd(wowjs.wowKeySpace);
  }
}

function ReachCombatDistance() {
  var target = me.target;
  if (target == null) return;
  if (target.mobSpell == 0) return; //if target not casting, don't care.  They migh fleeing
  var myReach = me.myCombatReach;
  var dx = me.x - target.x;
  var dy = me.y - target.y;
  var dz = me.z - target.z;
  var targetDist = Math.sqrt( (dx*dx) + (dy*dy) + (dz*dz) );
  //me.wowApproach(x,y,dist, timeout in seconds)
  if (myReach < targetDist) {
    //distance is too far to caster, try to reach to myReach-5 in 6 seconds
    me.wowLog("target too far, reaching");
    me.wowApproach(target.x, target.y,  myReach -5, 6);  
  }
}

//try to land on ground on salewaypoint. 
function endSaleLand(){
  var wpPos = me.wowGetWaypointAt(me.wayPointPos);
  if (wpPos == null) return;
  var zdiff = wpPos[2] - me.z;
  if (zdiff < -8) {  
      if (zdiff < -16) me.wowStopRun();
me.wowLog("flying down "+wpPos[2] +" mez="+ me.z);
      me.wowSendKey(wowjs.wowKeySit, 1);   
      for (var i = 0; i < 20; i++) {
        if (me.z <= wpPos[2] + 4) break;
        me.wowSleep(200);
      }    
      me.wowSendKey(wowjs.wowKeySit, 0);      
  }
}

//used while swiming or flying, it will adjust height according to waypoint
function followWaypointZ() {
  if (me.health <= 1) return; //don't care if dead
  var wpPos = me.wowGetWaypointAt(me.wayPointPos);
  if (wpPos == null) return;
  //me.wowLog("wp x=" + wpPos[0]+" y="+wpPos[1]+" z="+wpPos[2]);
  //if we are too far, don't follow height (went to loot etc)
  var xdiff = Math.abs(me.x-wpPos[0]);
  if (xdiff > 8) {
    wowjs.wowLog("Can't fix , xdiff too far " + xdiff);
    return;
  }
  var ydiff = Math.abs(me.y-wpPos[1]);
  if (ydiff > 8) {
    wowjs.wowLog("Can't fix , ydiff too far " + ydiff);
    return; 
  }
  
  if (me.prevState == "preLoot") {
     me.prevState = me.curState;
     return; //don't do this if we are looting.
  }
  me.prevState = me.curState;
  var zdiff = wpPos[2] - me.z;
  if (zdiff < -8) {  
      if (zdiff < -16) me.wowStopRun();
me.wowLog("flying down "+wpPos[2] +" mez="+ me.z);
      me.wowSendKey(wowjs.wowKeySit, 1);   
      for (var i = 0; i < 10; i++) {
        if (me.z <= wpPos[2] + 4) break;
        me.wowSleep(100);
      }    
      me.wowSendKey(wowjs.wowKeySit, 0);
      if (zdiff < -16) me.wowSendKey(wowjs.wowKeyUp, 1);    //press forward key to get going
  }
  if (zdiff > 8) {
me.wowLog("flying up");
      if (zdiff > 16) me.wowStopRun();
      for (var i = 0; i < 10; i++) {
        me.wowSendKey(wowjs.wowKeySpace, 1);   
	me.wowSleep(1000);
        me.wowSendKey(wowjs.wowKeySpace, 0);
        me.wowSleep(100);
        if (me.z >= wpPos[2] - 4) break;  
      }    
      if (zdiff > 16) me.wowSendKey(wowjs.wowKeyUp, 1);    //press forward key to get going
  }
}


function checkTimeOut() {
  if (wowjs.runTimeOutMinutes > 0) {
     var fightTime = wowjs.curTime - wowjs.wowZoloFightStart;
     if (fightTime > wowjs.runTimeOutMinutes*60) {
       wowjs.wowLog("Timeout after "+wowjs.runTimeOutMinutes+" minutes");
       wowjs.wowBotStop();
       //after user specified timeout, stone home.
       wowjs.wowDoFightAction("stone");
     }
  }
}


function authRemoteConnections() {
  var sockets = me.wowGetRemoteSockets();
  //will always sent PASS:password first.
  var PASS = "PASS:"+wowjs.wowGetBotSetting("REMOTEPASSWORD");
  
  for (var j in sockets) {
    var skt = sockets[j];
    //me.wowSendRemoteMsg(sockets[j], cmbMsgs[i]+"\r\n");
    if (authSockets[skt] == null) {
       var msg = me.wowGetRemoteMsg(skt);
       if (msg != "") {
          if (PASS == "PASS:") {
            //don't allow empty passwords.  Blizzard could prob your ports and find you
            wowjs.wowLog("Empty password not allowed for security reasons");
            return;
          }
          if (msg == PASS) {
            me.wowLog("got " + msg);
            authSockets[skt] = "OK";
          } else {
            wowjs.wowLog("Bad handshake, close tcp");
            wowjs.wowCloseRemoteSocket(skt);
            authSockets[skt] = null;
          }
       }
    }
  }

  for (var skt in authSockets) {
    if (authSockets[skt] == "OK") {
       var msg = wowjs.wowGetRemoteMsg(skt);
       if (msg != "") {
         if (msg.indexOf("TYPE:") == 0) {
            var type = msg.substring(5);
            wowjs.wowLog("Got remote type: " +type);
            authSockets[skt] = type;
         }
       }
    }
  }
}

function makeNpcRmtPosStr(npc) {
  return parseInt(npc.x)+" "+parseInt(npc.y)+" " + parseInt(npc.z)+ " " + parseInt(npc.heading*1000)+" " + npc.name;
}

function chechRemoteControl() {
  for (var skt in authSockets) {
    if (authSockets[skt] == "RMTCTL") {
       var msg = wowjs.wowGetRemoteMsg(skt);
       if (msg != "") {
         wowjs.wowLog("RMTCTL: " + msg);
         if (msg == "POS"){
           wowjs.wowSendRemoteMsg(skt, "POS: " + makeNpcRmtPosStr(me)+"\n");
         } 
         else  if(msg == "STOP") {
           doStone();
         }
	 else if (msg.indexOf("TALK:") == 0) {
           msg = msg.substring(5);
           wowjs.wowSendString("\n"+msg+"\n");
         }
         else if (msg == "SHOWPLAYERS") {
           var playersNearMe = me.wowGetPlayers();
           var str = "PLAYERS:";
           for (var j in playersNearMe) {
             var player = playersNearMe[j];
             str += makeNpcRmtPosStr(player)+ ";";
           }
           wowjs.wowSendRemoteMsg(skt,str+"\n");
         } else if (msg == "SHOWMOBS") {           
           var str = "MOBS:";
           for (var i = 0; i < me.toonCount; i++) {
             var npc = me.wowGetToon(i);
             if (!npc.isPlayer) {             
               str += makeNpcRmtPosStr(npc)+";";
             }
           }
           wowjs.wowSendRemoteMsg(skt,str+"\n");
         } else if (msg == "PICT") {
           wowjs.wowSendRemoteMsg(skt,"PICT:\n");
           wowjs.wowSendScreenJpeg(skt, 0.5);
         } else if (msg == "ECHO") {
           wowjs.wowSendRemoteMsg(skt,"ECHO\n");
         }
       }
    }
  }
}

function doRemoteControl() {
  authRemoteConnections();
  chechRemoteControl();
}


///////// flying and mining operations /////////////
var wantedMine = {'Fel Iron Deposit':1, 'Adamantite Deposit':1, 'Rich Adamantite Deposit':1}; 

var badMines = {}; 
function getDistToMe(itm) { 
  var xdiff = me.x - itm.x; 
  var ydiff = me.y - itm.y; 
  xdiff = xdiff*xdiff; 
  ydiff = ydiff*ydiff; 
  var dist = Math.sqrt(xdiff+ydiff); 
  return dist; 
} 

function checkMine() { 
    if (wowjs.fighterMode != "fly&mine") return;    
    var wpPos = me.wowGetWaypointAt(me.wayPointPos);
    var minFlightHeight = parseInt(wpPos[2]);
    wowjs.wowLog("need to fly back to " + minFlightHeight+" " + parseInt(me.z));
    var closestMine = null; 
    var minDist = 999; 
    for(var i = 0; i < wowjs.itemCount; i++) { 
      var itm = me.wowGetItem(i); 
      if (wantedMine[itm.name] == 1 && badMines[itm.x+" " + itm.y] != 1) { 
        var dist = getDistToMe(itm);         
        if (dist < minDist) { 
          me.wowLog("found " + itm.name+" " + parseInt(itm.x)+ " " + parseInt(itm.y)+" dist " + parseInt(dist)); 
          minDist = dist; 
          closestMine = itm; 
        } 
      } 
    } 
    if (closestMine != null && dist < 30) { 
      me.wowStopRun(); //stop running 
      me.wowTurnTo(closestMine.x,closestMine.y); 
      while (wowjs.wowBotRun) { 
        var dist = getDistToMe(closestMine); 
        if (dist < 5) break; 
        if (!wowjs.wowBotRun) break;
        //now keep turning to the mine and inches to it (by press/unpress forward arrow key) 
        me.wowTurnTo(closestMine.x,closestMine.y); 
        wowjs.wowSendKey( wowjs.wowKeyUp , 1); 
        wowjs.wowSleep(10); 
        wowjs.wowSendKey( wowjs.wowKeyUp , 0); 
        wowjs.wowSleep(10); 
      } 
      //at this point we are on top of the mine with x/y dist < 5, so need to press 'x' to go down 
      var lastz = me.z; 
      //keep going till our z position stops changing (touches ground); 
      while (wowjs.wowBotRun) { 
        wowjs.wowSendString("xxxxxx"); 
        if (me.z == lastz) break; 
        if (!wowjs.wowBotRun) break;
        lastz = me.z; 
      }
      wowjs.wowLog("landed near mine");
      if ( Math.abs(closestMine.z - me.z) > 10) { 
        //if height diff is to much, it might be underground mine, skip this location 
        var itm = closestMine; 
        badMines[itm.x+" " + itm.y] = 1; 
        wowjs.wowLog("vert dist to mine too far, must be under ground " + closestMine.z +","+ me.z);
      } 
      wowjs.wowLog("turning to mine");
      me.wowTurnTo(closestMine.x,closestMine.y); 
      wowjs.wowDoLoot(closestMine); 
      me = me = new WowObject(); //wowDoLoot will destroy the objects, so must rest me.
      //fly up 
      wowjs.wowSleep(200); 
      wowjs.wowDoFightAction("mount"); 
      while (wowjs.wowBotRun) { 
        fPressKeyStd(wowjs.wowKeySpace); 
        if (!wowjs.wowBotRun) break;
        if (me.z > minFlightHeight) break; 
      } 
      wowjs.wowLog("back to pos");
    } 
} 
///////// end flying and mining operations /////////////


//someone has a better one but I can't find it anymore, this is copied from Pillow Pants
function declam() {
  var clamnames = ["Big-mouth Clam",
            "Jaggal Clam",
            "Soft-shelled Clam",
            "Thick-shelled Clam",
            "Small Barnacled Clam"];
  for (var i in clamnames) {
    var name = clamnames[i];
    while (wowjs.wowBotRun) {
      var cnt = me.wowGetAllContainerItemCount(name);
      if (cnt == 0) break;
      wowjs.wowSleep(1000);
      wowjs.wowLog("clam count for " + name + " is " + cnt);
      wowjs.wowTalkViaClipboard("/use " + name);
      wowjs.wowSleep(1000);
      if (me.inCombat) break;
    }    
  }
  return true;
}


/////////////////////////////Unstuck script from ZStorm /////////////////////////////
var nStuckTimer = 0;
var LastPos = {x:0,y:0,z:0};

function resetStuck() {
  nStuckTimer = wowjs.curTime;
  StuckStrategy = ST_JUMP;
}

// Utility functions
function fDist3D(x,y,z) {
  var dx = me.x - x;
  var dy = me.y - y;
  var dz = me.z - z;

  dx = dx*dx;
  dy = dy*dy;
  dz = dz*dz;
  return Math.sqrt(dx+dy+dz);
}

// press key <k> for the specified time in milliseconds, k is keycode
function fPressKey(k,time) {
  var code = k; //me.wowGetKeyCode(k);
  me.wowSendKey(code, 1);
  me.wowSleep(time);
  me.wowSendKey(code, 0);
}

function fPressKeyStd(k) {
  fPressKey(k, 100);
}

// rolls <n> dice with <s> sides
function fRoll(s,n) {
    var res = 0;

    for (var i =0; i < n; i++) {
       res = res + Math.floor(Math.random()*s+1);
    }
    return res;
}

// Unsticking strategies are:
//
const ST_JUMP = 0;           //jump
const ST_STRAFE = 1;       //move either right or left for a few seconds
const ST_BACKTRACK = 2;  //return to last waypoint and try again
const ST_QUIT = 3;           //abort the run (TBD -- should hearth as well.)

var StuckStrategy = ST_JUMP;

function checkStuck() {
  if (wowjs.profileRunMode == "Defend") return; //don't check stuck in defend mode.
  if (me.curTime - nStuckTimer > 4) {
    var dist = fDist3D(LastPos.x,LastPos.y,LastPos.z);
    //me.wowLog("Dist: "+dist);

    if (dist < 4) {
       me.wowLog("Stuck. Moved " + dist + " meters.");

       switch (StuckStrategy) {
         case ST_JUMP:
           me.wowLog("  jumping.");

           fPressKeyStd(wowjs.wowKeySpace);
           StuckStrategy = ST_STRAFE;
           break;
         case ST_STRAFE:
           if (fRoll(100,1) <= 50) {
             me.wowLog("  strafing left.");
             fPressKey(wowjs.wowKeyStrafeLeft,2000);
           }else {
             me.wowLog("  strafing right.");
             fPressKey(wowjs.wowKeyStrafeRight,2000);
           }
           StuckStrategy = ST_BACKTRACK;
           break;
         case ST_BACKTRACK:
           me.wowLog("  backtracking to previous waypoint.");
           wowjs.wowStopRun();
           wowjs.wowSendKey(wowjs.wowKeyDown, 1);  //go back
           wowjs.wowSleep(200);
           fPressKey(wowjs.wowKeySpace, 100);        //jump 
           if (fRoll(100,1) <= 50) {
             me.wowLog("  strafing left.");
             fPressKey(wowjs.wowKeyLeft,2000);
           }else {
             me.wowLog("  strafing right.");
             fPressKey(wowjs.wowKeyRight,2000);
           }

           wowjs.wowSleep(200);
           wowjs.wowSendKey(wowjs.wowKeyDown, 0);  //stop back
           StuckStrategy = ST_QUIT;
           break;
         case ST_QUIT:
           me.wowLog("  can't unstick. Ending run.");
           wowjs.wowBotStop();
           break;
       }
    }
    else {
      //me.wowLog("not stuck");
      StuckStrategy = ST_JUMP;
    }
    nStuckTimer = me.curTime;
    LastPos.x = me.x; LastPos.y = me.y; LastPos.z = me.z;
  }
}
///////////////////////////// end Unstuck script from ZStorm /////////////////////////////

function wowDoUnsafeRefresh() {
  var refOK = me.wowUnsafeRefresh();
  if (refOK) {
    me = new WowObject();
  }
  return refOK;
}

function wowGetScreenScaledLoc(loc) {
  var moveToX = wowjs.wowScreenX + (loc.x/1024*me.wowScreenW) ;
  var moveToY = wowjs.wowScreenY + (loc.y/768*me.wowScreenH) -15;
  var res = {x:0,y:0,z:0};
  res.x = moveToX;
  res.y = moveToY;
  return res;
}

var me = new WowObject();
var wowjs = new WowObject();

//I am lazy, setup strafe keys this way.
var tempKey = 'q';
tempKey = wowjs.wowGetBotSetting("KEYSTRAFELEFT");
if (tempKey == '' || tempKey == null) tempKey = 'q';
wowjs.wowKeyStrafeLeft = wowjs.wowGetKeyCode(tempKey);

tempKey = wowjs.wowGetBotSetting("KEYSTRAFERIGHT");
if (tempKey == '' || tempKey == null) tempKey = 'e';
wowjs.wowKeyStrafeRight = wowjs.wowGetKeyCode(tempKey);


 var attacker = me.wowGetAttackingMob();

 if (attacker != null && attacker.valid) {
   me.wowLog(attacker.name+" is attacking me");
 }


/************* commented out code that shows other player, npcs
for (var i = 0 ;i < me.toonCount; i++) {
  var toon = me.wowGetToon(i);
  if (toon.isPlayer) {
     me.wowLog(" Player : " + toon.name+" " + toon.wowId +" " + toon.level+" xyz=("+toon.x+","+toon.y+","+toon.z+")");
  } else {
     me.wowLog(" computer " + toon.name+" " + toon.wowId +" " + toon.level+" xyz=("+toon.x+","+toon.y+","+toon.z+")");
     if (toon.isAttackAbleFaction) {
       me.wowLog("Attackable");
       //me.wowApproach(toon.x, toon.y);
       if (i > 2) break;
     }
  }
} 

**************/
//me.wowMoveMouse(100,100);
//me.wowSleep(1000);
//me.wowMoveMouse(200,200);
//me.wowMouseClick(1);  default right click, 0 left, 1 right.
//me.wowSendString("\nHello\n");
//var txt = me.wowReadFile("script.js");
//txt = me.wowExec("javac.exe",null,1);
//txt = me.wowExecReadOutput(me.execReadHandle);
//me.wowLog(txt);


 var whisperReplyFile = wowjs.wowReadFile("replies.txt");
 var whisperReplies = null;
 if (whisperReplyFile!= null && whisperReplyFile != "") whisperReplies = whisperReplyFile.split('\r\n');

//battle ground check function
var battleGroupExitCheck = null;

wowjs.wowZoloFightStart = wowjs.curTime; //get start time in seconds.

me.wowLog("before main");
//wowjs.wowOrbitRunTo(x,y);


if (wowjs.fighterMode == "fly&mine") {
  wowjs.checkZPos = false;  //fix fly and mine z post too far problem.
}

///// starting relog ///////
///// use of relog is not encouraged, because this stores username/password in settings.txt and could lead to others steal
///// your wow username and password.
var wowuser = wowjs.wowGetBotSetting("WOWUSER");
if ( (wowuser != "") && (wowuser != null) ) {
  var mainres = me.wowMain();  
  me.wowLog("after main " + mainres);
  wowjs.wowBotRun = true;
  if (wowjs.wowBotRun) {   
    wowjs.KillWOW();
    wowjs.wowSleep(1000);
    wowjs.StartWOW();
    wowjs.wowSleep(1000);
  }
while (wowjs.wowBotRun) {
  wowjs.wowBotRun = true;
  if (wowjs.wowBotRun) {  //if we ended but user haven't pressed stop button, means a disconnect
     me.wowLog("Starting AutoLogin... in 5s");
     me.wowSleep(5000);
     if (!wowjs.wowBotRun) break;
     var loc = wowGetScreenScaledLoc({x:521, y:431});
wowjs.wowLog("moving to " + loc.x+","+loc.y);
     me.wowMoveMouse(loc.x, loc.y);  //move to username field
     me.wowMouseClick(0);  //left click I think.
     me.wowSleep(500);
     wowjs.wowSendString(wowjs.wowGetBotSetting("WOWUSER"));
     loc = wowGetScreenScaledLoc({x:515, y:506});
wowjs.wowLog("moving to " + loc.x+","+loc.y);
     me.wowMoveMouse(loc.x, loc.y);  //move to password field
     me.wowSleep(500);
     me.wowMouseClick(0);  //click
     me.wowSleep(500);
     wowjs.wowSendString(wowjs.wowGetBotSetting("WOWPWD"));
     loc = wowGetScreenScaledLoc({x:513, y:566});
wowjs.wowLog("moving to " + loc.x+","+loc.y);
     me.wowMoveMouse(loc.x, loc.y);  //move to login button
     me.wowMouseClick(0);  //click.

     if (!wowjs.wowBotRun) break;
     wowjs.wowLog("waiting for next screen");
     me.wowSleep(15000); //waiting for next screen
     if (!wowjs.wowBotRun) break;
     loc = wowGetScreenScaledLoc({x:513, y:735});
     me.wowMoveMouse(loc.x, loc.y);  //move to username field
     me.wowSleep(500);
     me.wowMouseClick(0);  //click

     me.wowSleep(1000);
     if (!wowjs.wowBotRun) break;
     var waitingCnt = 0;
     while(me.wowBotRun) { //wait for loading
       var refOK2 = me.wowUnsafeRefresh();
       wowjs.wowSleep(2000);
       if (refOK2 == true) break;
       wowjs.wowLog("no logon, waiting..");
       waitingCnt++;
       if (waitingCnt > 240) {
         wowjs.wowLog("no logon, after 6 minutes, retrying");
         break;
       }
     }

     me = new WowObject();

     mainres = me.wowMain();  
     me.wowLog("after main " + mainres);

     wowjs.wowBotRun = true;
     if (wowjs.wowBotRun) {   
       wowjs.KillWOW();
       wowjs.wowSleep(1000);
       wowjs.StartWOW();
       wowjs.wowSleep(1000);
     }
  }
}

} //end of relogin stuff

//main method. call this for the main fighter routine.
//if you don't call it main routine will be executed anyway, but javascript won't presist.
checkNeedRepair();

//var notes = wowjs.wowWaypointNotes;
//for (var i  in notes) {
//  var note = notes[i];
//  wowjs.wowLog(i+" (" + note.x+" " + note.y + " " + note.z+") " + note.heading+" " + note.desc);
//}

//wowjs.wowFileLog("file.txt","testttest\n");
//wowjs.wowAddWaypointNote(0,1,2,3.1,'test');

//var allItems = me.wowGetMyItems(); 
//  for (var i in allItems) {
//   wowjs.wowLog("itm " + i + " " + allItems[i].name);
//}

var mainres = me.wowMain();  
if (mainres != null){
  me.wowLog("after main " + mainres);
}
wowjs.wowLog("done");

//shutdown computer when done if user wanted to.
if (wowjs.shutdownAtEnd) {
  wowjs.wowExec('shutdown -s -t 50');
}


